Source: https://leadping.ai/docs/api-reference/appointments/complete-an-appointment

# Complete an appointment.

Marks an appointment as completed using the expected revision to detect concurrent changes.

## Endpoint

```http
POST https://api.leadping.ai/appointments/{id}/complete
```

## Request examples

### cURL

```bash
curl --request POST \
  --url https://api.leadping.ai/appointments/{id}/complete \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '{
  "expectedRevision": 123
}'
```

### Python

```python
import requests

url = "https://api.leadping.ai/appointments/{id}/complete"

payload = { "expectedRevision": 123 }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

### C#

```csharp
using RestSharp;


var options = new RestClientOptions("https://api.leadping.ai/appointments/{id}/complete");
var client = new RestClient(options);
var request = new RestRequest("");
request.AddHeader("Authorization", "Bearer <token>");
request.AddJsonBody("{\n  \"expectedRevision\": 123\n}", false);
var response = await client.PostAsync(request);

Console.WriteLine("{0}", response.Content);
```

### Java

```java
HttpResponse<String> response = Unirest.post("https://api.leadping.ai/appointments/{id}/complete")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"expectedRevision\": 123\n}")
  .asString();
```

### JavaScript

```javascript
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({expectedRevision: 123})
};

fetch('https://api.leadping.ai/appointments/{id}/complete', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### Go

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.leadping.ai/appointments/{id}/complete"

	payload := strings.NewReader("{\n  \"expectedRevision\": 123\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(string(body))

}
```

### PHP

```php
<?php

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.leadping.ai/appointments/{id}/complete",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'expectedRevision' => 123
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
```

## Authorizations

### `Authorization`

- **Type:** `string`
- **Location:** Header
- **Required:** Yes

Authorization header using the Bearer scheme. Accepted values are Leadping user JWT access tokens and WorkOS organization API keys beginning with `sk_`.

## Path parameters

### `id`

- **Type:** `string`
- **Required:** Yes

The appointment identifier.

## Request body

**Content types:**

- `application/json`
- `text/json`
- `application/*+json`

The expected appointment revision.

Protects appointment actions against concurrent edits.

### `expectedRevision`

- **Type:** `integer<int64>`

The revision expected by the caller. The operation uses this value to protect appointment actions against concurrent edits.

Example:

```json
{
  "expectedRevision": 123
}
```

## Responses

### `200` — Success

The request completed successfully.

Content type: `application/json`

An appointment visible to the current user, with history populated on detail requests.

```json
{
  "isDemo": true,
  "createdAt": "2023-11-07T05:31:56Z",
  "modifiedAt": "2023-11-07T05:31:56Z",
  "history": [
    {
      "revision": 123,
      "type": "<string>",
      "at": "2023-11-07T05:31:56Z",
      "actorId": "<string>",
      "actorName": "<string>",
      "startAt": "2023-11-07T05:31:56Z",
      "reminderAt": "2023-11-07T05:31:56Z",
      "assignedToName": "<string>",
      "title": "<string>",
      "notes": "<string>"
    }
  ],
  "id": "<string>",
  "leadId": "<string>",
  "leadFirstName": "<string>",
  "leadLastName": "<string>",
  "leadEmail": "jsmith@example.com",
  "leadAvatarUrl": "<string>",
  "leadName": "<string>",
  "organizationId": "<string>",
  "organizationName": "<string>",
  "assignedToUserId": "<string>",
  "assignedToName": "<string>",
  "startAt": "2023-11-07T05:31:56Z",
  "timeZoneId": "<string>",
  "title": "<string>",
  "notes": "<string>",
  "status": "<string>",
  "revision": 123,
  "reminderAt": "2023-11-07T05:31:56Z",
  "dismissedAt": "2023-11-07T05:31:56Z"
}
```

#### Response fields

- `isDemo` — `boolean`
- `createdAt` — `null | string<date-time>`
- `modifiedAt` — `null | string<date-time>`
- `history` — `object[]`
  - An immutable snapshot of an appointment change and its actor.
  - `revision` — `integer<int64>`
  - `type` — `string`
  - `at` — `string<date-time>`
  - `actorId` — `null | string`
  - `actorName` — `null | string`
  - `startAt` — `string<date-time>`
  - `reminderAt` — `string<date-time>`
  - `assignedToName` — `string`
  - `title` — `string`
  - `notes` — `null | string`
- `id` — `string`
- `leadId` — `string`
- `leadFirstName` — `null | string`
- `leadLastName` — `null | string`
- `leadEmail` — `null | string<email>`
- `leadAvatarUrl` — `null | string<uri>`
- `leadName` — `string`
- `organizationId` — `string`
- `organizationName` — `null | string`
- `assignedToUserId` — `string`
- `assignedToName` — `string`
- `startAt` — `string<date-time>`
- `timeZoneId` — `string`
- `title` — `string`
- `notes` — `null | string`
- `status` — `string`
- `revision` — `integer<int64>`
- `reminderAt` — `string<date-time>`
- `dismissedAt` — `null | string<date-time>`

### `401` — Unauthorized

Authentication credentials are missing or invalid.

Content type: `application/problem+json`

```json
{
  "type": "about:blank",
  "title": "Unauthorized",
  "status": 401,
  "detail": "The request could not be completed."
}
```

The response may include a `WWW-Authenticate` header containing the Bearer authentication challenge returned when credentials are missing or invalid.

### `403` — Forbidden

The caller does not have permission to perform this operation.

Content type: `application/problem+json`

```json
{
  "type": "about:blank",
  "title": "Forbidden",
  "status": 403,
  "detail": "The request could not be completed."
}
```

### `409` — Conflict

The current resource state prevents this operation.

Content type: `application/problem+json`

```json
{
  "type": "about:blank",
  "title": "Conflict",
  "status": 409,
  "detail": "The request could not be completed."
}
```

### `429` — Too Many Requests

The API rate limit for this account or client has been exceeded.

Content type: `application/problem+json`

```json
{
  "type": "about:blank",
  "title": "Too Many Requests",
  "status": 429,
  "detail": "The request could not be completed."
}
```

The response may include a `Retry-After` header containing the number of seconds to wait before retrying the request.

## Standard problem-details response

Error responses use a standard problem-details object with the following fields:

- `type` — `null | string`
  - URI reference that identifies the problem type.
- `title` — `null | string`
  - Short, human-readable summary of the problem.
- `status` — `null | integer<int32>`
  - HTTP status code returned for the problem.
- `detail` — `null | string`
  - Human-readable explanation specific to this occurrence of the problem.
- `instance` — `null | string`
  - URI reference that identifies this specific occurrence of the problem.
- `errors` — `object`
  - Validation errors keyed by the JSON request field name. Present for request validation failures.
  - Each property contains an array of `string` values.
- `traceId` — `string`
  - Request trace identifier used to correlate this problem with Leadping diagnostics.

## Previous and next endpoints

- Previous: [Create an appointment.](https://leadping.ai/docs/api-reference/appointments/create-an-appointment)
- Next: [Cancel an appointment.](https://leadping.ai/docs/api-reference/appointments/cancel-an-appointment)
